<?php
/***************************************************************************
 *                     School Bulletin
 *  An administraive program to help display bulletin items within an organization
 *  Version: 0.1
 *  Copyright (C) 2006  Seema Ali
 *  Email: seema15 AT users DOT sourceforge DOT net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 	 
  require("../calendar/config.php");
	require("bulletinconfig.php");
	require("functions.php");
	$type 	= (int) $HTTP_GET_VARS['s'];//determines if it is a staff or a student bullein
																			//student=0, staff=1 and both=2
	if($type==1) $typeTitle="Staff";
	else				 $typeTitle="Student";
	
	$bulletin = " (bulletin='$type' or bulletin='2') ";
//--------------------------------------------------------------------------

//--------------------------------------------------------------------------	
  if($db)//already defined
  {
    //generate the headers to help a browser choose the correct application
    header( 'Content-type: application/msword' );
    header( 'Content-Disposition: inline, filename=bulletin.rtf');


		//pick the next school day
		$query  = "select date from days where date>now() order by date asc";
		$result = mysql_query($query);
		$nDays  = mysql_num_rows($result);
		
		if(date("n")>6)  $year = date("Y")+1;	 //if its the fall/winter months
		else						 $year = date("Y");
		
		if($nDays==0)  $nextDay = "$year-08-05";
		else
		{
		  $row = mysql_fetch_array($result);
			$nextDay = stripslashes($row[0]);
		}
	
    $date = date( 'F d, Y', mktime(0,0,0,substr($nextDay,5,2),substr($nextDay,8,2),substr($nextDay,0,4)));
		//end of picking next school day
  
    // open our template file
		$filename = 'bulletinDocument.rtf';
    $fp = fopen ( $filename, 'r' );

    //read our template into a variable
    $output = fread( $fp, filesize( $filename ) );
  
    fclose ( $fp );
  
		//----------------------------------------------------------------------
		//list all the entries
		
		$entries= "";
		$query  = "select * from bullentries left join category on (category.priority=bullentries.category) where start<='$nextDay' and '$nextDay'<=end and $bulletin order by start desc";
		$result = mysql_query($query);
		$num    = mysql_num_rows($result);
		
		for($i=0; $i<$num; $i++)
		{
		  $row = mysql_fetch_array($result);
			
			$title  = stripslashes($row['title']);
			$msg    = stripslashes($row['message']);
			$auth   = stripslashes($row['author']);
			$attach = stripslashes($row['attachment']);
			
			$temp = explode(" ", $auth);
			$auth = ucfirst($temp[0]{0});
			$n    = count($temp);
			
			if($n>1) $auth = $auth.". ".$temp[1];//i had a for loop, but it wasn't infinitely looping
			if($n>2) $auth = $auth." ".$temp[2]; //so this was a quick solution
			if($n>3) $auth = $auth." ".$temp[3];
			
			if($attach!="") $attach = "Please see the online bulletin for more info.";
			
			$entries = $entries." ".($i+1).".  {\ul {\b $title\b0}\ul0} $msg $attach {\i $auth}.\line\line";
			 
		} 
		
		//end of listing all the entries
		//----------------------------------------------------------------------				
		//----------------------------------------------------------------------
		//start of picking the day
		$query  = "select day from days where '$nextDay'=date";
		$result = mysql_query($query);
		$num    = mysql_num_rows($result);
		if($num)
		{
		  $row = mysql_fetch_array($result);
			$day = stripslashes($row[0]);
		}
		else
		{
		  $day = "";
		} 
		//end of picking the day		
		//----------------------------------------------------------------------		
		//----------------------------------------------------------------------		
		//pick the rotation number and info
		
 		$query  = "select * from rotation where start<='$nextDay' and '$nextDay'<=end";
		$result = mysql_query($query);
		$num    = mysql_num_rows($result);
		if($num)
		{
		  $row   = mysql_fetch_array($result);
			$s     = stripslashes($row['start']);
			$e     = stripslashes($row['end']);
			$id    = stripslashes($row['id']);
			$b1    = stripslashes($row['block1']);
			$b2    = stripslashes($row['block2']);			

			$start = date("F j,Y", mktime(0,0,0,substr($s,5,2),substr($s,8,2),substr($s,0,4)));
			$end   = date("F j,Y", mktime(0,0,0,substr($e,5,2),substr($e,8,2),substr($e,0,4)));
			
			if($day==1)     $blocks = "$b1";
			elseif($day==2) $blocks = "$b2";
			else						$blocks = "";
		}
		else
		{
		  $start = "";
			$end   = "";
			$id    = 0;
			$blocks = "";		//no longer using $blocks
		}
		//end of picking a rotation number
		//----------------------------------------------------------------------
		
		//----------------------------------------------------------------------		
		//create the document
    $output = str_replace( '<<entries>>',  $entries,    $output );
    $output = str_replace( '<<date>>',     $date,       $output );
		$output = str_replace( '<<rotNum>>',   $id,         $output );
		$output = str_replace( '<<rotStart>>', $start,      $output );
		$output = str_replace( '<<rotEnd>>',   $end,        $output );
		$output = str_replace( '<<SCHOOL>>',   SCHOOL_NAME, $output );

		$output = str_replace( '<<d11>>', $b1{0}, $output );
		$output = str_replace( '<<d21>>', $b2{0}, $output );
		$output = str_replace( '<<d12>>', $b1{1}, $output );
		$output = str_replace( '<<d22>>', $b2{1}, $output );
		$output = str_replace( '<<d13>>', $b1{2}, $output );
		$output = str_replace( '<<d23>>', $b2{2}, $output );
		$output = str_replace( '<<d14>>', $b1{3}, $output );
		$output = str_replace( '<<d24>>', $b2{3}, $output );


		$output = str_replace( '<<day>>', $day, $output );
		$output = str_replace( '<<S>>',   $typeTitle, $output );
		

    // send the generated document to the browser
    echo $output;
		//----------------------------------------------------------------------
  }
?>