<?
/***************************************************************************
 *                     School Bulletin
 *  An administraive program to help display bulletin items within an organization
 *  Version: 0.1
 *  Copyright (C) 2006  Seema Ali
 *  Email: seema15 AT users DOT sourceforge DOT net
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

function auth($login = '', $passwd = '')
{
	session_start();
	global $HTTP_SESSION_VARS;
	$authdata = $HTTP_SESSION_VARS['authdata'];
	
	if (!empty($login)) {
		$username = $login;
		$pw = $passwd;
		$register = true;
	} elseif (!empty($authdata['login'])) {
		$username = $authdata['login'];
		$pw = $authdata['password'];
		$register = false;
	} else {
		$auth = 0;
	}
	
	if (!empty($username)) {
		mysql_connect(DB_HOST, DB_USER, DB_PASS) or die(mysql_error());
		mysql_select_db(DB_NAME) or die(mysql_error());
		
		$sql = "SELECT * FROM " . DB_TABLE_PREFIX . "users WHERE username = '" . $username . "'";
		$sql .= " and bulletin='1'";
		$result = mysql_query($sql) or die(mysql_error());
		$row = mysql_fetch_assoc($result);

		if ( $row["password"] == $pw ) {
			if ($register) {
				$HTTP_SESSION_VARS['authdata'] = array('login'=>$row['username'], 'password'=>$row['password'], 'bulletin'=>$row['bulletin'], 'uid'=>$row['uid']);
			}
			$auth = $row['bulletin'];
		} else {
			unset($HTTP_SESSION_VARS['authdata']);
			$auth = 0;
		}
	}
   	return $auth;
}

/*
  errormsg() is used when the user enters the wrong combination of username and password
*/
function errormsg()
{
  echo "Please make sure that you entered the correct username or password.";
}

/*
  username() returns the first and last name of the user according
	to the session variable authdata, which contains the uid value 
*/
function username()
{
	session_start();
	global $HTTP_SESSION_VARS;

  mysql_connect(DB_HOST, DB_USER, DB_PASS) or die(mysql_error());
  mysql_select_db(DB_NAME) or die(mysql_error());
  
	$sql = "SELECT * FROM " . DB_TABLE_PREFIX . "users WHERE uid = '" . $HTTP_SESSION_VARS['authdata']['uid'] . "'";
  $sql .= " and bulletin='1'";
  $result = mysql_query($sql) or die(mysql_error());
  $row = mysql_fetch_assoc($result);
	
	$name = $row['fname']." ".$row['lname'];
	
	return $name;
}

function userID()
{
	session_start();
	global $HTTP_SESSION_VARS;
	$authdata = $HTTP_SESSION_VARS['authdata'];

  mysql_connect(DB_HOST, DB_USER, DB_PASS) or die(mysql_error());
  mysql_select_db(DB_NAME) or die(mysql_error());
  
  return $HTTP_SESSION_VARS['authdata']['uid'];
}


/*
  supervisionEditor() is used to determine users that have "special" access to the site
	The users with this access are supposed to be administrative/secretarial, who ever
	is responsible for maintaining the site.  
	The person would be able to enter the people for the supervision schedule, delete anyone's
	current/upcoming bulletin entries
	It returns true or false  
*/
function supervisionEditor()
{
	session_start();
	global $HTTP_SESSION_VARS;
	$authdata = $HTTP_SESSION_VARS['authdata'];

	$uid = $HTTP_SESSION_VARS['authdata']['uid'];

	//you have to know the db userids of the users that you want to give 
	//the ability to see everyone's entries and delete/edit them.
	//This was a quick and lazy solution.
	//You can determine how many people can have this priviledge, it doesn't 
	//have to be 3 users
	return ($uid==1 || $uid==2 || $uid==3);
}


/* 
  month($name) creates a select list box with the full name of the months
	in order starting with September and ending with June
	
	$name = HTML name of the select box
	$old is for the preassigned month value
*/
function month($name, $old='')
{
	echo '<SELECT NAME     = "'.$name.'">';
	
	//change the 21 in the for loop to 19
	for($i=9; $i<21; $i++)
	{
	 		$j=$i;
			if($i>12) $j=$i-12;	
	  	echo '<OPTION VALUE = '.$j; 
			if($j ==date("n") && $old=='') echo ' SELECTED';
			else if ($old==$j && $old!='') echo ' SELECTED'; 
			echo '>';
			echo date ("F", mktime (0,0,0,$i,12,12));
			echo '</OPTION>';
	}
	echo '</SELECT>';
}


/* 
  year($a) creates a select list box with the full name of the months
	in order starting with September and ending with June
	
	$a = HTML name of the select box
*/
function year($a, $old='')//$old is for the preassigned year value
{
  echo "<select name='$a'>";
	$year = date("Y");
	
	for($i=$year-2; $i<=$year+2; $i++)
	{
  	echo "<option value='$i'";
  	if($i==$year && $old=='') echo " selected ";
		else if ($old==$i && $old!='') echo ' SELECTED'; 
  	echo ">$i</option>";
	}
  echo "</select>";
}


/*
  selections() lists all the menu options in the bulletin home page
*/
function selections()
{
?>
		<BR>
		<a href="EntryForm.php">Bulletin Entry Form</a><P>
		<a href="bulletinOnline.php?s=0">Student Bulletin</a><BR>
		<a href="bulletinOnline.php?s=1">Staff Bulletin</a><P>
		<a href="bulletinDocument.php?s=0">Next school days's Student Bulletin (Document Form)</a><BR>
		<a href="bulletinDocument.php?s=1">Next school days's Staff Bulletin (Document Form)</a><P>
		<a href="future.php">View, edit or delete your current and upcoming bulletin entries</a><P>
<?
    if(supervisionEditor())
		{
			echo "<BR><a href='delete.php'>Trim the fat (Delete entries)</a>";
			echo '<table summary="">';
			
			echo "<form method=post action='setday.php' name='monthYear'>";
      echo "  <tr>";
      echo "    <td>Set School Days (1,2,Pro-D...)</td>";
			echo "		<td>";
			month("month");
			echo "    </td>";
			echo "		<td>";
			year("year");
			echo "    </td>";
			echo "		<td>";
			echo '      <input type="button" value="GO" onClick="submitMonthYear()">';
			echo "    </td>";
      echo "  </tr>";
			echo "</form>";			
      echo "</table>";
      }

			echo "<P><a href='index.php?action=logout'>Logout</a>";
}


//for the supervision.php page
//creates session variable teachers that lists the first, last and usernames
function listteachers()
{
	session_start();
	$authdata = $HTTP_SESSION_VARS['authdata'];//might not need this

  mysql_connect(DB_HOST, DB_USER, DB_PASS) or die(mysql_error());
  mysql_select_db(DB_NAME) or die(mysql_error());
	
	$sql = "select username, fname, lname from ".DB_TABLE_PREFIX . "users order by lname";
	$result = mysql_query($sql) or die(mysql_error());
	$num = mysql_num_rows($result);
	
	$_SESSION["teachers"] = array();
	for($i=0; $i<$num; $i++)
	{
	  $row = mysql_fetch_array($result);
		$_SESSION["teachers"][$i] = array();
		$_SESSION["teachers"][$i]['username']  = stripslashes($row['username']);
		$_SESSION["teachers"][$i]['firstName'] = stripslashes($row['fname']);
		$_SESSION["teachers"][$i]['lastName']  = stripslashes($row['lname']);
	}
}

//creates a select box filled with teacher names
//$name is the name of the select box
//$username is the name of the user to be selected
function selectteachers($name, $username)
{
	session_start();
	$num = count($_SESSION["teachers"]);
	
	echo "<select name='$name' STYLE='font-family:monospace; font-size:8pt; text-decoration: none; width:120px'>";
	echo "<option value=''></option>";
	for($i=0; $i<$num; $i++)
	{
	  echo "<option value='".$_SESSION["teachers"][$i]['username']."' ";
		if($username==$_SESSION["teachers"][$i]['username']) echo " SELECTED";
		echo ">";
		echo $_SESSION["teachers"][$i]['lastName']." ".substr($_SESSION["teachers"][$i]['firstName'],0,1).". ";
		echo "</option>";
	}
	echo "</select>";
}


/*
  Returns the username given the current userid which is stored in the session 
	variable authdata
*/
function loginname()
{
	session_start();
	global $HTTP_SESSION_VARS;
	$authdata = $HTTP_SESSION_VARS['authdata'];

  mysql_connect(DB_HOST, DB_USER, DB_PASS) or die(mysql_error());
  mysql_select_db(DB_NAME) or die(mysql_error());
  
	$sql = "SELECT * FROM " . DB_TABLE_PREFIX . "users WHERE uid = '" . $HTTP_SESSION_VARS['authdata']['uid'] . "'";
  $result = mysql_query($sql) or die(mysql_error());
  $row = mysql_fetch_assoc($result);
	
	$name = $row['username'];
	
	return $name;
}

	//Determine what was checked off on the entry form: Student, Staff or Both
	function bulletinfunction($a)
	{
	  if($a==0) echo "Student";
		else if($a==1) echo "Staff";
		else 					 echo "Both";
	} 
?>